
macro minsw arg1, arg2
{
	local ..behind
	mov ax, arg2
	cmp arg1, ax
	jle ..behind
		mov arg1, ax
	..behind:
}

macro maxsw arg1, arg2
{
	local ..behind
	mov ax, arg2
	cmp arg1, ax
	jge ..behind
		mov arg1, ax
	..behind:
}

macro movqmm0 arg1, arg2
{
	movq mm0, arg2
	movq arg1, mm0
}

macro pminsw arg1, arg2
{
	mov [tmp_ax], ax
	movq qword [tmp_mm0], mm0
	movqmm0 qword  [tmp_ar1], arg1
	movqmm0  qword [tmp_ar2], arg2
	minsw word [tmp_ar1], word [tmp_ar2]
	minsw word [tmp_ar1 + 1], word [tmp_ar2 + 1]
	minsw word [tmp_ar1 + 2], word [tmp_ar2 + 2]
	minsw word [tmp_ar1 + 3], word [tmp_ar2 + 3]	
	movqmm0 arg1,  qword [tmp_ar1]
	movq mm0,  qword [tmp_mm0]
	mov ax, [tmp_ax]
}

macro pmaxsw arg1, arg2
{
	mov [tmp_ax], ax
	movq qword [tmp_mm0], mm0
	movqmm0 qword  [tmp_ar1], arg1
	movqmm0  qword [tmp_ar2], arg2
	maxsw word [tmp_ar1], word [tmp_ar2]
	maxsw word [tmp_ar1 + 1], word [tmp_ar2 + 1]
	maxsw word [tmp_ar1 + 2], word [tmp_ar2 + 2]
	maxsw word [tmp_ar1 + 3], word [tmp_ar2 + 3]	
	movqmm0 arg1,  qword [tmp_ar1]
	movq mm0,  qword [tmp_mm0]
	mov ax, [tmp_ax]
}